%define debug_package %{nil}

# Turn off strip'ng of binaries
%global __strip /bin/true

%define         major_version S39
%define         minor_version 1

Name:           shen-sbcl
Version:        %{major_version}.%{minor_version}
Release:        1%{?dist}
Summary:        Shen programming language

License:        BSD
URL:            http://www.shenlanguage.org/
Source0:        https://www.shenlanguage.org/Download/%{major_version}.%{minor_version}.zip
Patch0:         sbcl-version-2.5.6.patch

BuildRequires:  sbcl, vim-common

%description
Shen is a portable functional programming language that offers
 pattern matching,
 lambda calculus consistency,
 macros for defining domain specific languages,
 optional lazy evaluation,
 static type checking based on sequent calculus, one of the most powerful systems for typing in functional programming
 portability over many languages,
 an integrated fully functional Prolog,
 an inbuilt compiler-compiler.
 runs under CLisp, SBCL, Clojure, Scheme, Ruby, Python, the JVM, Haskell and Javascript
 has a BSD kernel

%prep
%setup -q -n %{major_version}
%patch -P0 -p1

%build
sbcl --eval '(load "install.lsp")'

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin
# remove SBCL Build ID
BUILD_ID=`eu-readelf -n sbcl-shen.exe | egrep '^    Build ID: ' | sed -e 's/^    Build ID: //'`
xxd -p sbcl-shen.exe | tr -d '\n' | sed -e "s/$BUILD_ID/0000000000000000000000000000000000000000/" | fold -c256 | xxd -r -p > $RPM_BUILD_ROOT/usr/bin/shen-sbcl

%files
%license Lib/LICENSE
%defattr(0755,root,root,-)
%{_bindir}/shen-sbcl

%changelog
* Sat Jul 26 2025 Builder <builder@fractal.zone>
- Initial RPM build of Shen 39.1 on SBCL 2.5.6

* Sun Jun 15 2025 Builder <builder@fractal.zone>
- Initial RPM build of Shen 39.1 on SBCL 2.5.5

* Sun May 26 2024 Builder <builder@fractal.zone>
- Initial RPM build of Shen 38.3 on SBCL 2.4.4
